IDENTIFICATION DIVISION.
PROGRAM-ID.	RPGOOO.
DATE-WRITTEN.	APRIL 13, 1976.
AUTHOR.	HAL ROACH.
INSTALLATION.	CERRITOS COLLEGE.
REMARKS.	PROGRAM TO UPDATE O DATA CARD.
ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
SOURCE-COMPUTER.	DECSYSTEM-10.
OBJECT-COMPUTER.	DECSYSTEM-10.
SPECIAL-NAMES.
	CONSOLE IS TTY.
	CHANNEL (1) IS HOF.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
	SELECT PROGRAM-FILE ASSIGN TO DSK
	ACCESS MODE IS RANDOM
	ACTUAL KEY IS PROGRAM-KEY
	FILE LIMIT IS 99999.
DATA DIVISION.
FILE SECTION.
FD	PROGRAM-FILE
	BLOCK CONTAINS 8 RECORDS
	LABEL RECORDS ARE STANDARD
	VALUE OF IDENTIFICATION IS PROGRAM-IDENTIFICATION
	DATA RECORD IS PROGRAM-RECORD.
01	PROGRAM-RECORD	PIC X(90).
WORKING-STORAGE SECTION.
77	CHECK-14		PIC X(14).
77	NUM-IT-1		PIC 9.
77	NUM-IT-2		PIC 99.
77	NUM-IT-3		PIC 999.
77	NUM-IT-4		PIC 9(4).
77	ELE-9			PIC 99.
77	CLEAR-IT		PIC X(36)	VALUE SPACES.
77	CLEAR-3300		PIC X(28)	VALUE SPACES.
77	ERROR-CODE		PIC X.
77	I			PIC S9(5)	COMP.
77	J			PIC S9(5)	COMP.
77	K			PIC S9(5)	COMP.
77	L			PIC 9(5)	COMP.
77	PROGRAM-KEY		PIC 9(5)	COMP.
77	NEXT-PROGRAM		PIC X(6).
01	ELEM-NO.
	02 ELE-NUM	PIC XX.
01	NO-ELEM REDEFINES ELEM-NO.
	02 NUM-ELE	PIC 99.
01	DATA-STORAGE.
	02 DATA-A	PIC X(26)	OCCURS 19 TIMES.
01	THE-DATA.
	02 DATA-18.
	  03 DATA-16.
	    04 DATA-14.
	      05 DATA-13.
	        06 DATA-12.
	          07 DATA-1	PIC X.
	          07 DATA-2	PIC X.
	        06 DATA-3	PIC X.
	      05 DATA-4	PIC X.
	    04 DATA-6		PIC XX.
	  03 DATA-8		PIC XX.
	02 FILLER		PIC X(18).
01	PROGRAM-ZERO.
	02 FILLER		PIC X(80).
	02 PROGRAM-REC-NO	PIC 9(5).
	02 PROGRAM-LAST-REC	PIC 9(5).
01	PROGRAM-MAIN.
	02 PROGRAM-PAGE		PIC 99.
	02 PROGRAM-LINE		PIC 999.
	02 PROGRAM-FORM		PIC X.
	02 PROGRAM-INFO.
	  03 FILLER		PIC X.
	  03 STAR-COMMENT	PIC X(67).
	02 PROGRAM-IDENT	PIC X(6).
	02 PROGRAM-ACT-REC	PIC 9(5).
	02 PROGRAM-FILL		PIC 9(5).
01	PROG-INFO.
	02 FILENAME.
	  03 OA-BLANK.
	    04 THE-STARE	PIC X.
	    04 FILLER		PIC X(6).
	  03 OA-CHECK		PIC X.
	02 TYPE-IT	PIC X.
	02 STA-SEL	PIC X.
	02 SPA-BEF	PIC X.
	02 SPA-AFT	PIC X.
	02 SKI-BEF	PIC XX.
	02 BEF-SKI REDEFINES SKI-BEF	PIC Z9.
	02 SKI-AFT	PIC XX.
	02 AFT-SKI REDEFINES SKI-AFT	PIC Z9.
	02 NOT-1	PIC X.
	02 IND-1	PIC XX.
	02 DNI-1 REDEFINES IND-1	PIC 99.
	02 NOT-2	PIC X.
	02 IND-2	PIC XX.
	02 DNI-2 REDEFINES IND-2	PIC 99.
	02 NOT-3	PIC X.
	02 IND-3	PIC XX.
	02 DNI-3 REDEFINES IND-3	PIC 99.
	02 FIE-NAM	PIC X(6).
	02 EDI-COD	PIC X.
	02 BLA-AFT	PIC X.
	02 END-POS	PIC X(4).
	02 POS-END REDEFINES END-POS	PIC ZZZ9.
	02 PAC-BIN	PIC X.
	02 CON-EDI	PIC X(26).
	02 FILLER	PIC X(4).
01	PROG-COMMENT.
	02 THE-STAR	PIC X	VALUE "*".
	02 THE-COMMENT	PIC X(67).
01	TUBE-TITLE.
	02 TUBE-LINE-0.
	  03 FILLER		PIC X(4)	VALUE "PAGE".
	  03 DISPLAY-PAGE	PIC ZZZ.
	  03 FILLER		PIC X(5)	VALUE " LINE".
	  03 DISPLAY-LINE	PIC Z(4).
	  03 FILLER		PIC X(34)	VALUE
	  " O DATA CARD".
	02 TUBE-LINE-1	PIC X(50)	VALUE
	"ELEMENT ELEMENT                       ELEMENT".
	02 TUBE-LINE-2	PIC X(50)	VALUE
	"NUMBER  DESCRIPTION                   [ENTRY]".
01	TUBE-DISPLAY.
	02 FILLER	PIC X(58)	VALUE
	"FILENAME                      [        ]".
	02 FILLER	PIC X(58)	VALUE
	"TYPE                          [ ]".
	02 FILLER	PIC X(58)	VALUE
	"STACKER SELECT/FETCH OVERFLOW [ ]".
	02 FILLER	PIC X(58)	VALUE
	"SPACE BEFORE                  [ ]".
	02 FILLER	PIC X(58)	VALUE
	"SPACE AFTER                   [ ]".
	02 FILLER	PIC X(58)	VALUE
	"SKIP BEFORE                   [  ]".
	02 FILLER	PIC X(58)	VALUE
	"SKIP AFTER                    [  ]".
	02 FILLER	PIC X(58)	VALUE
	"NOT - 1                       [ ]".
	02 FILLER	PIC X(58)	VALUE
	"INDICATOR - 1                 [  ]".
	02 FILLER	PIC X(58)	VALUE
	"NOT - 2                       [ ]".
	02 FILLER	PIC X(58)	VALUE
	"INDICATOR - 2                 [  ]".
	02 FILLER	PIC X(58)	VALUE
	"NOT - 3                       [ ]".
	02 FILLER	PIC X(58)	VALUE
	"INDICATOR - 3                 [  ]".
	02 FILLER	PIC X(58)	VALUE
	"FIELD NAME                    [      ]".
	02 FILLER	PIC X(58)	VALUE
	"EDIT CODES                    [ ]".
	02 FILLER	PIC X(58)	VALUE
	"BLANK AFTER                   [ ]".
	02 FILLER	PIC X(58)	VALUE
	"END POSITION IN OUTPUT RECORD [    ]".
	02 FILLER	PIC X(58)	VALUE
	"PACKED OR BINARY FIELD        [ ]".
	02 FILLER	PIC X(58)	VALUE
	"CONSTANT OR EDIT WORD         [                          ]".
01	DISPLAY-TUBE REDEFINES TUBE-DISPLAY.
	02 FILLER	OCCURS 19 TIMES.
	  04 THE-TUBE	PIC X(58).
01	THE-NUMBER.
	02 II		PIC Z(5).
	02 FILLER	PIC XXX.
01	PROGRAM-IDENTIFICATION.
	02 PROGRAM-NAME		PIC X(6).
	02 PROGRAM-EXT		PIC XXX		VALUE "TMP".
01	PASS-IT.
	02 THE-FILE	PIC X(6).
	02 THE-TERM	PIC X.
	02 THE-ACTION	PIC XXX.
	02 THE-PAGE	PIC 99.
	02 THE-LINE	PIC 999.
	02 THE-FORM	PIC X.
	02 R-TYPE	PIC X.
01	ALL-DATA.
	02 ALL-1	PIC X.
	02 ALL-23.
	  03 ALL-2	PIC X.
	  03 ALL-3	PIC X.
	02 FILLER	PIC X(23).
PROCEDURE DIVISION.
START SECTION.
BEGIN.
	ENTER MACRO TRAP.
	MOVE SPACES TO PASS-IT.
*	DISPLAY "PASS-IT = " WITH NO ADVANCING ACCEPT PASS-IT.
	ENTER MACRO GTPRMS USING PASS-IT "X".
	IF THE-TERM = "A" OR "D" OR "V" OR "3" OR "B"
		GO TO CONT-PROG.
	DISPLAY "THE DRIVER PROGRAM WAS NOT USED".
	STOP RUN.
CONT-PROG.
	MOVE THE-FILE TO PROGRAM-NAME.
	IF  THE-ACTION = "CHG"
		PERFORM FIND-REC THRU END-FIND-REC.
	PERFORM CLEAR-SCREEN.
	ENTER MACRO SETTY USING "NO CRLF".
	ENTER MACRO SETTY USING "WIDTH 80".
	ENTER MACRO SETTY USING "FORM".
	IF THE-STARE = "*"
		MOVE 1 TO K
		MOVE THE-STARE TO DATA-1
		GO TO COMMENT-CHECK.
	MOVE THE-PAGE TO DISPLAY-PAGE.
	MOVE THE-LINE TO DISPLAY-LINE.
	DISPLAY TUBE-LINE-0.
	DISPLAY TUBE-LINE-1.
	DISPLAY TUBE-LINE-2.
	MOVE 3 TO I.
LOOP-DISPLAY.
	ADD 1 TO I.
	IF I > 22 GO TO END-DISPLAY.
	SUBTRACT 3 FROM I GIVING K.
	MOVE K TO II.
	MOVE 1 TO J.
	PERFORM CURSOR.
	DISPLAY THE-NUMBER THE-TUBE (K) WITH NO ADVANCING.
	MOVE 40 TO J.
	PERFORM CURSOR.
	DISPLAY DATA-A (K).
	GO TO LOOP-DISPLAY.
END-DISPLAY.
	IF THE-ACTION = "ADD"
		GO TO ADD-IT.
FIND-NUMBER.
	MOVE 23 TO I.
	MOVE 1 TO J.
	PERFORM CURSOR.
	DISPLAY "ELEMENT NUMBER = " WITH NO ADVANCING.
	MOVE SPACES TO ELE-NUM.
	DISPLAY ELE-NUM WITH NO ADVANCING.
	MOVE 18 TO J.
	PERFORM CURSOR.
	ACCEPT ELE-NUM.
	IF ELE-NUM = "EN"
		PERFORM CHG-REC THRU END-CHG-REC
		PERFORM CLEAR-SCREEN
		GO TO END-IT.
	MOVE NUM-ELE TO ELE-9.
	EXAMINE ELE-NUM REPLACING ALL SPACES BY ZERO.
	IF ELE-NUM IS NOT NUMERIC
		PERFORM BAD-NUMBER
		GO TO FIND-NUMBER.
	IF ELE-9 < 1 OR ELE-9 > 19
		PERFORM BAD-NUMBER
		GO TO FIND-NUMBER.
	MOVE 23 TO I.
	MOVE 20 TO J.
	PERFORM CURSOR.
	PERFORM CLEAR-LINE.
	MOVE ELE-9 TO I.
	ADD 3 TO I.
BY-NUM.
	MOVE 40 TO J.
	PERFORM CURSOR.
	SUBTRACT 3 FROM I GIVING K.
	MOVE K TO II.
ACCEPT-CHG.
	ACCEPT DATA-A (K).
	IF THE-ACTION = "ADD"
		MOVE DATA-A (K) TO ALL-DATA.
	IF ALL-1 = "/"
		GO TO CHECK-SLASH.
	IF K = 1 GO TO COMMENT-CHECK.
EDIT-IT.
	PERFORM THE-EDIT.
	IF ERROR-CODE = "X"
		MOVE SPACE TO ERROR-CODE
		MOVE 40 TO J
		PERFORM CURSOR
		GO TO ACCEPT-CHG.
	PERFORM CLEAN-IT.
	MOVE 40 TO J.
	PERFORM CURSOR.
	DISPLAY DATA-A (K).
	IF K = 9 OR 11 OR 13 OR 15
		PERFORM CLEAR-NEXT.
	IF THE-ACTION = "ADD" GO TO LOOP-VALUE.
	GO TO FIND-NUMBER.
CHECK-SLASH.
	IF ALL-2 = "E"
		GO TO END-VALUE.
	MOVE ALL-23 TO NUM-IT-2.
	EXAMINE ALL-23 REPLACING ALL SPACES BY ZEROS.
	IF (ALL-23 NOT NUMERIC) OR (NUM-IT-2 > 19) OR (NUM-IT-2 = ZERO)
		MOVE 50 TO J
		PERFORM CURSOR
		DISPLAY " BAD SWITCH"
		MOVE 40 TO J
		PERFORM CURSOR
		GO TO ACCEPT-CHG.
	MOVE NUM-IT-2 TO L.
	ADD 2 TO L.
	PERFORM CLEAN-IT.
	GO TO LOOP-VALUE.
CLEAN-IT.
	MOVE 47 TO J.
	PERFORM CURSOR.
	PERFORM CLEAR-LINE.
	MOVE 1 TO J.
	PERFORM CURSOR.
	DISPLAY THE-NUMBER THE-TUBE (K) WITH NO ADVANCING.
CLEAR-NEXT.
	MOVE 47 TO J.
	ADD 1 TO I.
	PERFORM CURSOR.
	PERFORM CLEAR-LINE.
	SUBTRACT 1 FROM I.
COMMENT-CHECK.
	MOVE DATA-A (K) TO THE-DATA.
	IF DATA-1 NOT = "*" GO TO EDIT-IT.
	PERFORM CLEAR-SCREEN.
	IF THE-ACTION = "CHG"
		DISPLAY "OLD COM" STAR-COMMENT.
	DISPLAY "         1    1    2    2    3    3    4    4    5    5    6    6    7   7".
	DISPLAY "       8901234567890123456789012345678901234567890123456789012345678901234".
	DISPLAY "NEW COM" WITH NO ADVANCING ACCEPT THE-COMMENT.
	MOVE PROG-COMMENT TO PROG-INFO.
	IF THE-ACTION = "CHG"
		PERFORM CHG-REC THRU END-CHG-REC
		PERFORM CLEAR-SCREEN
		GO TO END-IT.
	GO TO END-VALUE.
BAD-NUMBER.
	MOVE 23 TO I.
	MOVE 20 TO J.
	PERFORM CURSOR
	DISPLAY "BAD NUMBER " ELE-NUM.
FIND-REC.
	OPEN I-O PROGRAM-FILE.
	MOVE 1 TO PROGRAM-KEY.
	READ PROGRAM-FILE INVALID KEY
	DISPLAY "BAD READ CHG FILE " PROGRAM-KEY STOP RUN.
	MOVE PROGRAM-RECORD TO PROGRAM-ZERO.
LOOP-CHG.
	ADD 1 TO PROGRAM-KEY.
	IF PROGRAM-KEY > PROGRAM-LAST-REC
		DISPLAY "LOGIC ERROR IN PROGRAM" STOP RUN.
	READ PROGRAM-FILE INVALID KEY
	DISPLAY "BAD READ CHG FILE " PROGRAM-KEY STOP RUN.
	MOVE PROGRAM-RECORD TO PROGRAM-MAIN.
	IF PROGRAM-PAGE NOT = THE-PAGE GO TO LOOP-CHG.
	IF PROGRAM-LINE NOT = THE-LINE GO TO LOOP-CHG.
	MOVE PROGRAM-INFO TO PROG-INFO.
	MOVE FILENAME TO DATA-A (1).
	MOVE TYPE-IT TO DATA-A (2).
	MOVE STA-SEL TO DATA-A (3).
	MOVE SPA-BEF TO DATA-A (4).
	MOVE SPA-AFT TO DATA-A (5).
	MOVE SKI-BEF TO DATA-A (6).
	MOVE SKI-AFT TO DATA-A (7).
	MOVE NOT-1 TO DATA-A (8).
	MOVE IND-1 TO DATA-A (9).
	MOVE NOT-2 TO DATA-A (10).
	MOVE IND-2 TO DATA-A (11).
	MOVE NOT-3 TO DATA-A (12).
	MOVE IND-3 TO DATA-A (13).
	MOVE FIE-NAM TO DATA-A (14).
	MOVE EDI-COD TO DATA-A (15).
	MOVE BLA-AFT TO DATA-A (16).
	MOVE END-POS TO DATA-A (17).
	MOVE PAC-BIN TO DATA-A (18).
	MOVE CON-EDI TO DATA-A (19).
END-FIND-REC.
	EXIT.
CHG-REC.
	MOVE PROG-INFO TO PROGRAM-INFO.
	MOVE PROGRAM-MAIN TO PROGRAM-RECORD.
	WRITE PROGRAM-RECORD INVALID KEY
	DISPLAY "BAD WRITE CHG " PROGRAM-KEY STOP RUN.
	CLOSE PROGRAM-FILE.
END-CHG-REC.
	EXIT.
ADD-IT.
	MOVE 3 TO I.
	MOVE I TO L.
LOOP-VALUE.
	ADD 1 TO L.
	IF L > 22 GO TO END-VALUE.
	MOVE L TO I.
	GO TO BY-NUM.
END-VALUE.
	PERFORM CLEAR-SCREEN.
	PERFORM WRITE-ADD THRU END-WRITE-ADD.
	GO TO END-IT.
CURSOR.
	IF THE-TERM = "A" ENTER MACRO CURSER USING I,J.
	IF THE-TERM = "D" ENTER MACRO CA1520 USING I,J.
	IF THE-TERM = "V" ENTER MACRO CAVT52 USING I,J.
	IF THE-TERM = "3" ENTER MACRO CA3300 USING I,J.
	IF THE-TERM = "B" ENTER MACRO CAB100 USING I,J.
CLEAR-SCREEN.
	IF THE-TERM = "A" OR "D"
		ENTER MACRO TTYOUT USING 14.
	IF THE-TERM = "V"
		ENTER MACRO CLVT52.
	IF THE-TERM = "3"
		ENTER MACRO TTYOUT USING 35,37,37,37,37.
	IF THE-TERM = "B"
		ENTER MACRO CLB100.
CLEAR-LINE.
	IF THE-TERM = "A" OR "V" OR "B"
		DISPLAY CLEAR-IT WITH NO ADVANCING.
	IF THE-TERM = "D"
		ENTER MACRO TTYOUT USING 35.
	IF THE-TERM = "3"
		DISPLAY CLEAR-3300 WITH NO ADVANCING.
THE-EDIT.
	IF K = 1 PERFORM EDIT-1 THRU END-EDIT-1.
	IF K = 2 PERFORM EDIT-2 THRU END-EDIT-2.
	IF K = 3 PERFORM EDIT-3 THRU END-EDIT-3.
	IF K = 4 PERFORM EDIT-4 THRU END-EDIT-4.
	IF K = 5 PERFORM EDIT-5 THRU END-EDIT-5.
	IF K = 6 PERFORM EDIT-6 THRU END-EDIT-6.
	IF K = 7 PERFORM EDIT-7 THRU END-EDIT-7.
	IF K = 8 PERFORM EDIT-8 THRU END-EDIT-8.
	IF K = 9 PERFORM EDIT-9 THRU END-EDIT-9.
	IF K = 10 PERFORM EDIT-10 THRU END-EDIT-10.
	IF K = 11 PERFORM EDIT-11 THRU END-EDIT-11.
	IF K = 12 PERFORM EDIT-12 THRU END-EDIT-12.
	IF K = 13 PERFORM EDIT-13 THRU END-EDIT-13.
	IF K = 14 PERFORM EDIT-14 THRU END-EDIT-14.
	IF K = 15 PERFORM EDIT-15 THRU END-EDIT-15.
	IF K = 16 PERFORM EDIT-16 THRU END-EDIT-16.
	IF K = 17 PERFORM EDIT-17 THRU END-EDIT-17.
	IF K = 18 PERFORM EDIT-18 THRU END-EDIT-18.
	IF K = 19 PERFORM EDIT-19 THRU END-EDIT-19.
EDIT-1.
	MOVE DATA-A (1) TO THE-DATA.
	MOVE DATA-18 TO FILENAME.
	MOVE FILENAME TO DATA-A (1).
END-EDIT-1.
	EXIT.
EDIT-2.
	MOVE DATA-A (2) TO THE-DATA.
	IF DATA-1 = "N"
		GO TO N-CHECK.
	IF DATA-1 = "R"
		GO TO R-CHECK.
	IF DATA-1 = SPACE OR "H" OR "D" OR "T" OR "E"
		MOVE DATA-1 TO TYPE-IT
		MOVE TYPE-IT TO DATA-A (2)
		GO TO END-EDIT-2.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,H,D,T, OR E".
	MOVE "X" TO ERROR-CODE.
	GO TO END-EDIT-2.
N-CHECK.
	IF (OA-BLANK = SPACE AND OA-CHECK = "A")
		MOVE DATA-1 TO TYPE-IT
		MOVE TYPE-IT TO DATA-A (2)
		GO TO END-EDIT-2.
	GO TO NR-ERROR.
R-CHECK.
	IF (OA-BLANK = SPACE AND OA-CHECK = "R")
		MOVE DATA-1 TO TYPE-IT
		MOVE TYPE-IT TO DATA-A (2)
		GO TO END-EDIT-2.
NR-ERROR.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY "'OR' OR 'AND' CONFUSION"
	MOVE "X" TO ERROR-CODE.
END-EDIT-2.
	EXIT.
EDIT-3.
	MOVE DATA-A (3) TO THE-DATA.
	IF DATA-1 = "D"
		GO TO D-CHECK.
	IF DATA-1 = SPACE OR "2" OR "4" OR "5" OR "F" OR "A"
		MOVE DATA-1 TO STA-SEL
		MOVE STA-SEL TO DATA-A (3)
		GO TO END-EDIT-3.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,2,4,5,F, OR A".
	MOVE "X" TO ERROR-CODE.
	GO TO END-EDIT-3.
D-CHECK.
	IF (OA-BLANK = SPACE AND OA-CHECK = "A") AND DATA-A(2) = "N"
		MOVE DATA-1 TO STA-SEL
		MOVE STA-SEL TO DATA-A(3)
		GO TO END-EDIT-3.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY "'AND' CONFUSION"
	MOVE "X" TO ERROR-CODE.
END-EDIT-3.
	EXIT.
EDIT-4.
	MOVE DATA-A (4) TO THE-DATA.
	IF DATA-1 = SPACE OR ZERO OR 1 OR 2 OR 3 OR "D"
		MOVE DATA-1 TO SPA-BEF
		MOVE SPA-BEF TO DATA-A (4)
		GO TO END-EDIT-4.
ERROR-4.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER 0,1,2,3 OR D".
	MOVE "X" TO ERROR-CODE.
END-EDIT-4.
	EXIT.
EDIT-5.
	MOVE DATA-A (5) TO THE-DATA.
	IF DATA-1 = SPACE OR ZERO OR 1 OR 2 OR 3 OR "D"
		MOVE DATA-1 TO SPA-AFT
		MOVE SPA-AFT TO DATA-A (5)
		GO TO END-EDIT-5.
ERROR-5.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER 0,1,2,3, OR D".
	MOVE "X" TO ERROR-CODE.
END-EDIT-5.
	EXIT.
EDIT-6.
	MOVE DATA-A (6) TO THE-DATA.
	IF DATA-12 = SPACES
		GO TO MOVE-6.
	IF DATA-1 = "A" OR "B"
		GO TO CHECK-NUM-6.
	MOVE DATA-12 TO NUM-IT-2.
	EXAMINE DATA-12 REPLACING ALL SPACES BY ZEROS.
	IF DATA-12 NOT NUMERIC GO TO ERROR-6.
	IF (NUM-IT-2 > ZERO) AND (NUM-IT-2 < 100)
		MOVE NUM-IT-2 TO BEF-SKI
		MOVE SKI-BEF TO DATA-A (6)
		GO TO END-EDIT-6.
	GO TO ERROR-6.
CHECK-NUM-6.
	IF DATA-2 NOT NUMERIC
		GO TO ERROR-6.
	IF DATA-1 = "B" AND DATA-2 > 2
		GO TO ERROR-6.
MOVE-6.
	MOVE DATA-12 TO SKI-BEF.
	MOVE SKI-BEF TO DATA-A (6).
	GO TO END-EDIT-6.
ERROR-6.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1-99,A0-A9, OR B0-B2".
	MOVE "X" TO ERROR-CODE.
END-EDIT-6.
	EXIT.
EDIT-7.
	MOVE DATA-A (7) TO THE-DATA.
	IF DATA-12 = SPACES
		GO TO MOVE-7.
	IF DATA-1 = "A" OR  "B"
		GO TO CHECK-NUM-7.
	MOVE DATA-12 TO NUM-IT-2.
	EXAMINE DATA-12 REPLACING ALL SPACES BY ZEROS.
	IF DATA-12 NOT NUMERIC GO TO ERROR-7.
	IF (NUM-IT-2 > ZERO) AND (NUM-IT-2 < 100)
		MOVE NUM-IT-2 TO AFT-SKI
		MOVE SKI-AFT TO DATA-A (7)
		GO TO END-EDIT-7.
	GO TO ERROR-7.
CHECK-NUM-7.
	IF DATA-2 NOT NUMERIC
		GO TO ERROR-7.
	IF DATA-1 = "B" AND DATA-2 > 2
		GO TO ERROR-7.
MOVE-7.
	MOVE DATA-12 TO SKI-AFT.
	MOVE SKI-AFT TO DATA-A (7).
	GO TO END-EDIT-7.
ERROR-7.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1-99,A0-A9, OR B0-B2".
	MOVE "X" TO ERROR-CODE.
END-EDIT-7.
	EXIT.
EDIT-8.
	MOVE DATA-A (8) TO THE-DATA.
	IF DATA-1 = SPACE OR "N"
		MOVE DATA-1 TO NOT-1
		MOVE NOT-1 TO DATA-A (8)
		GO TO END-EDIT-8.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , , OR N".
	MOVE "X" TO ERROR-CODE.
END-EDIT-8.
	EXIT.
EDIT-9.
	MOVE DATA-A (9) TO THE-DATA.
	IF DATA-12 = SPACE OR "MR" OR "LR" OR "1P" OR "L0" OR "OA" OR "OB"
		OR "OC" OR "OD" OR "OE" OR "OF" OR "OG" OR "OV"
		GO TO MOVE-9.
	IF DATA-1 = "L" OR "H" OR "U"
	GO TO CHECK-NUM-9.
	MOVE DATA-12 TO NUM-IT-2.
	EXAMINE DATA-12 REPLACING ALL SPACES BY ZEROS.
	IF DATA-12 NOT NUMERIC GO TO ERROR-9.
	IF (NUM-IT-2 > ZERO) AND (NUM-IT-2 < 100)
		MOVE NUM-IT-2 TO DNI-1
		MOVE IND-1 TO DATA-A (9)
		GO TO END-EDIT-9.
	GO TO ERROR-9.
CHECK-NUM-9.
	IF DATA-2 NOT NUMERIC
		GO TO ERROR-9.
	IF DATA-2 = ZERO
		GO TO ERROR-9.
	IF DATA-1 = "U" AND DATA-2 = 9
		GO TO ERROR-9.
MOVE-9.
	MOVE DATA-12 TO IND-1.
	MOVE IND-1 TO DATA-A (9).
	GO TO END-EDIT-9.
ERROR-9.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1-99,L1-L9,H1-H9," WITH NO ADVANCING.
	ADD 1 TO I.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " U1-U8,OA-OG,OV,MR,LR,1P, OR L0".
	SUBTRACT 1 FROM I.
	MOVE "X" TO ERROR-CODE.
END-EDIT-9.
	EXIT.
EDIT-10.
	MOVE DATA-A (10) TO THE-DATA.
	IF DATA-1 = SPACE OR "N"
		MOVE DATA-1 TO NOT-2
		MOVE NOT-2 TO DATA-A (10)
		GO TO END-EDIT-10.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , , OR N".
	MOVE "X" TO ERROR-CODE.
END-EDIT-10.
	EXIT.
EDIT-11.
	MOVE DATA-A (11) TO THE-DATA.
	IF DATA-12 = SPACE OR "MR" OR "LR" OR "1P" OR "L0" OR "OA" OR "OB"
		OR "OC" OR "OD" OR "OE" OR "OF" OR "OG" OR "OV"
		GO TO MOVE-11.
	IF DATA-1 = "L" OR "H" OR "U"
		GO TO CHECK-NUM-11.
	MOVE DATA-12 TO NUM-IT-2.
	EXAMINE DATA-12 REPLACING ALL SPACES BY ZEROS.
	IF DATA-12 NOT NUMERIC
		GO TO ERROR-11.
	IF (NUM-IT-2 > ZERO) AND (NUM-IT-2 < 100)
		MOVE NUM-IT-2 TO DNI-2
		MOVE IND-2 TO DATA-A (11)
		GO TO END-EDIT-11.
	GO TO ERROR-11.
CHECK-NUM-11.
	IF DATA-2 NOT NUMERIC
		GO TO ERROR-11.
	IF DATA-2 = ZERO
		GO TO ERROR-11.
	IF DATA-1 = "U" AND DATA-2 = 9
		GO TO ERROR-11.
MOVE-11.
	MOVE DATA-12 TO IND-2.
	MOVE IND-2 TO DATA-A (11).
	GO TO END-EDIT-11.
ERROR-11.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1-99,L1-L9,H1-H9," WITH NO ADVANCING.
	ADD 1 TO I.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " U1-U8,OA-OG,OV,MR,LR,1P, OR L0".
	SUBTRACT 1 FROM I.
	MOVE "X" TO ERROR-CODE.
END-EDIT-11.
	EXIT.
EDIT-12.
	MOVE DATA-A (12) TO THE-DATA.
	IF DATA-1 = SPACE OR "N"
		MOVE DATA-1 TO NOT-3
		MOVE NOT-3 TO DATA-A (12)
		GO TO END-EDIT-12.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , , OR N".
	MOVE "X" TO ERROR-CODE.
END-EDIT-12.
	EXIT.
EDIT-13.
	MOVE DATA-A (13) TO THE-DATA.
	IF DATA-12 = SPACE OR "MR" OR "LR" OR "1P" OR "L0" OR "OA" OR "OB"
		OR "OC" OR "OD" OR "OE" OR "OF" OR "OG" OR "OV"
		GO TO MOVE-13.
	IF DATA-1 = "L" OR "H" OR "U"
		GO TO CHECK-NUM-13.
	MOVE DATA-12 TO NUM-IT-2.
	EXAMINE DATA-12 REPLACING ALL SPACES BY ZEROS.
	IF DATA-12 NOT NUMERIC GO TO ERROR-13.
	IF (NUM-IT-2 > ZERO) OR (NUM-IT-2 < 100)
		MOVE NUM-IT-2 TO DNI-3
		MOVE IND-3 TO DATA-A (13)
		GO TO END-EDIT-13.
CHECK-NUM-13.
	IF DATA-2 NOT NUMERIC
		GO TO ERROR-13.
	IF DATA-2 = ZERO
		GO TO ERROR-13.
	IF DATA-1 = "U" AND DATA-2 = 9
		GO TO ERROR-13.
MOVE-13.
	MOVE DATA-12 TO IND-3.
	MOVE IND-3 TO DATA-A (13).
	GO TO END-EDIT-13.
ERROR-13.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1-99,L1-L9,H1-H9," WITH NO ADVANCING.
	ADD 1 TO I.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " U1-U8,OA-OG,OV,MR,LR,1P, OR L0".
	SUBTRACT 1 FROM I.
	MOVE "X" TO ERROR-CODE.
END-EDIT-13.
	EXIT.
EDIT-14.
	MOVE DATA-A (14) TO THE-DATA.
	MOVE DATA-16 TO FIE-NAM.
	MOVE FIE-NAM TO DATA-A (14).
END-EDIT-14.
	EXIT.
EDIT-15.
	MOVE DATA-A (15) TO THE-DATA.
	IF DATA-1 = SPACE OR 1 OR 2 OR 3 OR 4 OR "A" OR "B" OR "C"
		OR "D" OR "J" OR "K" OR "L" OR "M" OR "X" OR "Y" OR "Z"
		MOVE DATA-1 TO EDI-COD
		MOVE EDI-COD TO DATA-A (15)
		GO TO END-EDIT-15.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,1,2,3,4,A,B,C,D," WITH NO ADVANCING.
	ADD 1 TO I.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " J,K,L,M,X,Y, OR Z".
	SUBTRACT 1 FROM I.
	MOVE "X" TO ERROR-CODE.
END-EDIT-15.
	EXIT.
EDIT-16.
	MOVE DATA-A (16) TO THE-DATA.
	IF DATA-1 = SPACE OR "B"
		MOVE DATA-1 TO BLA-AFT
		MOVE BLA-AFT TO DATA-A (16)
		GO TO END-EDIT-16.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , , OR B".
	MOVE "X" TO ERROR-CODE.
END-EDIT-16.
	EXIT.
EDIT-17.
	MOVE DATA-A (17) TO THE-DATA.
	IF DATA-14 = SPACES GO TO MOVE-17.
	MOVE DATA-14 TO NUM-IT-4.
	MOVE DATA-14 TO CHECK-14.
	EXAMINE CHECK-14 REPLACING ALL SPACES BY ZEROS.
	IF CHECK-14 NOT NUMERIC GO TO MOVE-17.
	MOVE NUM-IT-4 TO POS-END.
	MOVE END-POS TO DATA-A (17).
	GO TO END-EDIT-17.
MOVE-17.
	MOVE DATA-14 TO END-POS.
	MOVE END-POS TO DATA-A (17).
END-EDIT-17.
	EXIT.
EDIT-18.
	MOVE DATA-A (18) TO THE-DATA.
	IF DATA-1 = SPACE OR "P" OR "B"
		MOVE DATA-1 TO PAC-BIN
		MOVE PAC-BIN TO DATA-A (18)
		GO TO END-EDIT-18.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , ,P, OR B".
	MOVE "X" TO ERROR-CODE.
END-EDIT-18.
	EXIT.
EDIT-19.
	MOVE DATA-A (19) TO THE-DATA.
	IF DATA-1 = SPACE OR "'"
		MOVE THE-DATA TO CON-EDI
		MOVE CON-EDI TO DATA-A (19)
		GO TO END-EDIT-19.
	MOVE 50 TO J.
	PERFORM CURSOR.
	DISPLAY " ENTER , , OR ' TO START CONSTANT OR EDIT WORD".
	MOVE "X" TO ERROR-CODE.
END-EDIT-19.
	EXIT.
WRITE-ADD.
	OPEN I-O PROGRAM-FILE.
	MOVE 1 TO PROGRAM-KEY.
	READ PROGRAM-FILE INVALID KEY
	DISPLAY "BAD READ " PROGRAM-KEY STOP RUN.
	MOVE PROGRAM-RECORD TO PROGRAM-ZERO.
	MOVE PROGRAM-LAST-REC TO PROGRAM-REC-NO PROGRAM-ACT-REC.
	ADD 1 TO PROGRAM-LAST-REC.
	MOVE PROGRAM-LAST-REC TO PROGRAM-KEY.
	MOVE THE-FILE TO PROGRAM-IDENT.
	MOVE THE-PAGE TO PROGRAM-PAGE.
	MOVE THE-LINE TO PROGRAM-LINE.
	MOVE THE-FORM TO PROGRAM-FORM.
	MOVE PROG-INFO TO PROGRAM-INFO.
	MOVE PROGRAM-MAIN TO PROGRAM-RECORD.
WRITE-ADD-A.
	WRITE PROGRAM-RECORD INVALID KEY
	DISPLAY "BAD WRITE " PROGRAM-KEY STOP RUN.
	MOVE 1 TO PROGRAM-KEY.
	MOVE PROGRAM-ZERO TO PROGRAM-RECORD.
	WRITE PROGRAM-RECORD INVALID KEY
	DISPLAY "BAD WRITE " PROGRAM-KEY STOP RUN.
	CLOSE PROGRAM-FILE.
END-WRITE-ADD.
	EXIT.
END-IT.
	MOVE PROGRAM-NAME TO THE-FILE.
	MOVE "RPGSYS" TO NEXT-PROGRAM.
	ENTER MACRO SYSPRG USING NEXT-PROGRAM, PASS-IT.
END-PROGRAM.
	STOP RUN.
